/**
 * 1. Daten holen 2. Daten parsen 3. View aufbauen 4. View Funktionalität 5. los
 */

;
(function($) {

	var kbb;
	kbb = this.kbb = {};
	kbb.widgetName = "StickyNotes";

	kbb.editModeSize = 'L';
	kbb.infoModeSize = 'L';
	
	kbb.locale = "en";

	kbb.font = "Arial";
	kbb.fontSize = 18;
	
	kbb.dataPath = "data/";

	kbb.smartTextProperties = {
		x : 100,
		y : 100
	};
	kbb.noteWidth = 200;
	kbb.noteHeight = 100;
	
	kbb.widgetWidth = 220;
	kbb.widgetHeight = 120;
	
	kbb.colors = ['yellow', 'green', 'orange', 'blue', 'pink', 'gray'];	
	kbb.startElement = 0;
	//kbb.currentColor;// = kbb.colors[kbb.startElement];
	
	kbb.editModeFormElements = [ {
		type : 'stickyColorSelect',
		label : 'Select Color',
		name : 'stickyColorSelect',
		initial : 'blue'
	}, {
		type : 'checkbox',
		label : 'Toggle color by tapping sticky note',
		name : 'toggleColor',
		initial : 0
	}, {
		type : 'headline2',
		label: 'Options'
		}, {
			/*		type : 'checkbox',
		label : 'Auto convert handwritten text',
		name : 'autoConvertHandwritten',
		initial : 0
	}, {
	type : 'checkbox',
		label : 'Allow any object on sticky note',
		name : 'allowAnyObject',
		initial : 0
	}, {*/
		type : 'okCancel',
		okName : 'saveForm',
		cancelName : 'cancelForm'
	}, {
		type : 'headline',
		label: 'Create'
	}, {
		type : 'headline2',
		label: 'Make all selected objects sticky notes'
	}, {
		type : 'button',
		name : 'makeSelectedSticky',
		label : 'Create',
		onclick : kbb.makeSelectedSticky
	}

	];
	
	kbb.cancelForm = function() {
		
		EM.hideForm();
	};
	
	
	kbb.editMode = function() {
		
		KBBUTIL.editModeSize = kbb.editModeSize;
		KBBUTIL.addEditMode(kbb.editModeFormElements);
		KBBUTIL.infoModeSize = kbb.infoModeSize;
		KBBUTIL.addInfoMode();		
	};
	
	
	kbb.initFromPersistance = function() {
	
		KBBUTIL.log("kbb.initFromPersistance");
		
		var inlineImage = KBBUTIL.load('inlineImage');
		if(inlineImage != "not-found") {
			
			$('#widgetContainer').css('background-image', 'url(' + inlineImage + ')').css('background-size', '90px 80px'); //ck sets it to hardwired size at beginning
			$('.stickyColorsDropper').css('background-image', 'url(' + inlineImage + ')').css('background-size', '90px 80px');
			
		} else {
			
			var stickyColor = KBBUTIL.load('stickyColorSelect');

			stickyColor = (stickyColor == "not-found") ? 'blue' : stickyColor;
			$('#widgetContainer').css('background-image', 'url(' + kbb.dataPath + stickyColor + '.png)');
		}
		
		kbb.resizeToImageSize();
	};
	
	
	kbb.resizeToImageSize = function () {
		
		KBBUTIL.log("resizeToImageSize inlineImageObject: " + KBBUTIL.load("inlineImageObjectWidth") +" "+ KBBUTIL.load("inlineImageObjectHeight"));
		
		
		
		var inlineImageCode = KBBUTIL.load('inlineImageCode');
		
		var widget = KBBUTIL.getWidgetObject();
		if(inlineImageCode != "not-found") {
			
			var bgObject = NB.page.addObjectFromXML(inlineImageCode);
			widget.width = parseInt(bgObject.width) + 20;
			widget.height = parseInt(bgObject.height) + 20;

			var w = bgObject.width;
			var h = bgObject.height;

			kbb.noteWidth = w;
			kbb.noteHeight = h;
			
			var bgSize = w +" px "+ h +" px";
			// KBBUTIL.log("bgSize "+ bgSize);			
			$('#widgetContainer').css('background-size',  (widget.width  - 20) + 'px '+ (widget.height - 20)  + 'px' );  // '180px 30px'); //bgSize);				
			
			$('body').css('width', bgObject.width);
			$('body').css('height', bgObject.height);
			$('#dropper').css('width', bgObject.width);
			$('#dropper').css('height', bgObject.height);			
			
			bgObject.deleteObject();
			
		} else {
			
			widget.width = 220;//kbb.widgetWidth;
			widget.height = 120;//kbb.widgetHeight;
			
			$('body').css('width', widget.width);
			$('body').css('height', widget.height);
			$('#dropper').css('width', widget.width);
			$('#dropper').css('height', widget.height);				
		}	
	};
	
	kbb.makeSelectedSticky = function() {
		
		var objects = KBBUTIL.getAllSelectedPageObjects();
		var numX = 0;
		var numY = 0;
		
		for(var i=0; i<objects.length; i++) {
			
			KBBUTIL.log("make Selected Sticky " + objects[i].guid);
			
			if(numX == 4) {
				
				numX = 0;
				numY++;
			}
			
			kbb.createPostIt(objects[i].guid, numX, numY);
			
			numX++;			
		}	
	};
	

	kbb.createPostIt = function(guid, numX, numY) {

		numX = (numX === undefined) ? 0 : numX;
		numY = (numY === undefined) ? 0 : numY;
		
		var obj = NB.getObject(guid);
		var objType = obj.type;
		
		if(objType == "widget")
				return;
		
		if (/*KBBUTIL.load("allowAnyObject") == '1' &&*/ (objType == "shape" || objType == "ellipse") ) {

			var inlineImageCode = KBBUTIL.load('inlineImageCode');
			var bgObject = null;
			
			if(inlineImageCode != "not-found") {

				bgObject = NB.page.addObjectFromXML(inlineImageCode);
			}
			
			if(bgObject === null) {

				var stickyColor = KBBUTIL.load('stickyColorSelect');

				stickyColor = (KBBUTIL.inArray(stickyColor, kbb.colors) === false) ? 'blue' : stickyColor;
				background = new NB.objectPrototype.file( kbb.dataPath + stickyColor + ".png"); //yellow
				background.x = background.y = 10;
				
				bgObject = NB.addObject(background);
				
			}
			
			bgObject.x = numX*bgObject.width; //position.x;
			bgObject.y = numY*bgObject.height; //position.y;

			
			var factor = 1;
			var maxW = kbb.noteWidth - 20;
			var maxH = kbb.noteHeight - 20; 
		
			if( obj.height > maxH) {
				
				factor = maxH /obj.height;
				obj.height = maxH;
				obj.width *=factor;
			} else if ( obj.width > maxW) {
				
				factor = maxW /obj.width;
				obj.width = maxW;
				obj.height *=factor;
			}
			
			obj.x = bgObject.x + (bgObject.width / 2) - (obj.width / 2);
			obj.y = bgObject.y + (bgObject.height / 2) - (obj.height / 2);
			
			
			
			NB.page.groupObjects([bgObject, obj]);
		}
		else if ( (objType == "shape") || (objType == "ellipse") ) {
			
			//nix
			
		} else {
			
			var background;
			var bgObject = null;
			
			var textColor = (obj.font !== undefined) ? obj.font.color : null;
			
			var inlineImageCode = KBBUTIL.load('inlineImageCode');
			
		
			if(inlineImageCode != "not-found") {

				bgObject = NB.page.addObjectFromXML(inlineImageCode);
			}

			/**
			 * fallback, falls bild fehlerhaft oder kein custombg gesetzt ist
			 */
			if(bgObject === null) {
				
				var stickyColor = KBBUTIL.load('stickyColorSelect');
				
				stickyColor = (KBBUTIL.inArray(stickyColor, kbb.colors) === false) ? 'blue' : stickyColor;
				background = new NB.objectPrototype.file( kbb.dataPath + stickyColor + ".png"); //yellow
				background.x = background.y = 10;
				
				bgObject = NB.addObject(background);
				
			}
						
			
			//var position = KBBUTIL.nextFreeSpace(bgObject);
			bgObject.x = numX*bgObject.width; //position.x;
			bgObject.y = numY*bgObject.height; //position.y;

			var textObject;
			
			KBBUTIL.log("obj.type "+ obj.type);
			/* || obj.type != 'ink'*/
			
			if(KBBUTIL.load("autoConvertHandwritten") != '1' || obj.type != 'ink') {
			
				textObject = obj;
			} else {
				
				var txt = obj.getText();
				var text = new NB.objectPrototype.text( txt );
				text.font.name = kbb.font;
				text.font.size = kbb.fontSize;
				
				if(textColor !== null)
					text.font.color = textColor;
				textObject = NB.addObject(text);	
			}

			
			var factor = 1;
			var maxW = kbb.noteWidth - 20;
			var maxH = kbb.noteHeight - 20; 
			
			if( textObject.height > maxH) {
				
				factor = maxH /textObject.height;
				textObject.height = maxH;
				textObject.width *=factor;
			} else if ( textObject.width > maxW) {			
				
				factor = maxW /textObject.width;
				textObject.width = maxW;
				textObject.height *=factor;
			}
		
			// Moving the text in the middle of the box
			textObject.x = bgObject.x + (bgObject.width / 2) - (textObject.width / 2);
			textObject.y = bgObject.y + (bgObject.height / 2) - (textObject.height / 2);
			
			// Grouping
			NB.page.groupObjects([bgObject, textObject]);
		}
			
	};
	
		
	kbb.droppedImageForBackground = function(guid) {
		
		var inlineImageObject = NB.getObject(guid);
		
		KBBUTIL.log("inlineImageObject: " + inlineImageObject.width +" "+ inlineImageObject.height);
		KBBUTIL.save("inlineImageObjectWidth", inlineImageObject.width);
		KBBUTIL.save("inlineImageObjectHeight", inlineImageObject.height);
		
		var inlineImageCode = NB.getObject(guid).toXML();
	    var xmlDoc = $.parseXML( inlineImageCode );
	    $xml = $( xmlDoc );
	    var inlineImage = $xml.find('image').attr('xlink:href');
	    
	    $('.stickyColorsDropper').css('background-image', 'url(' + inlineImage + ')').css('background-size', '90px 80px');
	    
	    KBBUTIL.save('inlineImageCode', inlineImageCode);
	    KBBUTIL.save('inlineImage', inlineImage);
	    
	    $('#widgetContainer').removeClass("selected");
		$('.stickyColorElement').removeClass("selected");	
		$('.hook').show();
	    
	    
	};
	

	kbb.addEvents = function() {

		$('#converter').click(function() {

			$(this).hide();
			var obj = KBBUTIL.getObjectOnMe();
			
			if(obj === undefined)				
				return;

			kbb.createPostIt(obj.guid, kbb.objectToText);
		});
		
		
		$('#dropper').click(function() {
			
			if(KBBUTIL.load("inlineImage") != "not-found" || 
						KBBUTIL.load("toggleColor") != '1') return;

			kbb.startElement++;
			kbb.startElement = (kbb.startElement >= kbb.colors.length) ? 0 : kbb.startElement;
			
			KBBUTIL.save('stickyColorSelect', kbb.colors[kbb.startElement]);
			KBBUTIL.log("kbb.colors[kbb.startElement] "+ kbb.colors[kbb.startElement]);
			
			$('#widgetContainer').css('background-image', 'url('+ kbb.dataPath + kbb.colors[kbb.startElement] +'.png)')
					.addClass("selected");
			
		});


		NB.helpers.handwritable( $("#widget"), function(text, obj) {
			
			if(EM.mode === true) return;
			
			obj = KBBUTIL.getObjectOnMe();
			
			if(obj == null) return;
			
			kbb.createPostIt(obj.guid);
			//obj.deleteObject();
			
		}, { timeToRecognize: 2 });		
		
		NB.addObserver("inkingFinishedEvent", function(evt) {
			
			var position = new Object();
			position.x = evt.eventData['x'];
			position.y = evt.eventData['y'];	
			
			
			if(NB.getHostObject().contains(position.x, position.y)) {

				//$('#converter').show();
			}
			
		});

		
		NB.addObserver("dndDropEvent", function(evt) {

			for ( var guid in evt.eventData) {

				var chk = NB.getObject(guid);

//				if (NB.getHostObject().contains(chk.x, chk.y)) {

				if(
						NB.getHostObject().contains(chk.x, chk.y) ||
						NB.getHostObject().contains(chk.x + 50, chk.y + 50) ||
						NB.getHostObject().contains(chk.x - 50 , chk.y - 50) 
				) {
						  

					if(EM.mode === false) {
						
						kbb.createPostIt(guid, kbb.objectToText);
					} else {
						
						if(chk.type == 'image' /*&& KBBUTIL.collision(chk, $('#dropper')) == true*/) {
							
							kbb.droppedImageForBackground(guid);
							$("#stickyColorsDropperLine1").text(NB.localize("drop"));
							$("#stickyColorsDropperLine2").text(NB.localize("image here"));
							chk.deleteObject();
						} else {
							$("#stickyColorsDropperLine1").text(NB.localize("Invalid"));
							$("#stickyColorsDropperLine2").text(NB.localize("image"));
						}
					}
				}
			}

		});


		

		// NEXT AND LAST STEP
		KBBUTIL.moveToBack();
	};

	

	

	kbb.getViewStage = function() {

		var html = "";

		html += '<div id="dropper"> ' +			 
			'</div>' +
			'<div id="converter" style="display:none">(+)</div>';

		return html;
	};

	kbb.createView = function() {

		kbb.html = '<section class="container">' + kbb.getViewStage()
				+ '<div class="clearer"></div>' + '</section>';

		kbb.element.html(kbb.html);

		kbb.initFromPersistance();
		kbb.editMode();
		
		$('#widget').addClass(kbb.widgetName);
		
		// NEXT STEP
		kbb.addEvents();
	};


	$.fn.startUP = function(locale) {

		kbb.locale = locale;
		kbb.element = $(this);

		//KBBUTIL.log(kbb.element);

		// NEXT STEP
		kbb.createView();
		NB.localization.translateHtmlElements();
	};


})(jQuery);


$('#widgetContainer').startUP(locale);